.\" -*-nroff-*-
.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "2.00",
.\"     date            = "13 February 2001",
.\"     time            = "08:59:38 MST",
.\"     filename        = "bibsearch.man",
.\"     address         = "Center for Scientific Computing
.\"                        University of Utah
.\"                        Department of Mathematics, 322 INSCC
.\"                        155 S 1400 E RM 233
.\"                        Salt Lake City, UT 84112-0090
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 585 1640, +1 801 581 4148",
.\"     URL             = "http://www.math.utah.edu/~beebe",
.\"     checksum        = "27012 1410 5563 42543",
.\"     email           = "beebe@math.utah.edu, beebe@acm.org,
.\"                        beebe@computer.org, beebe@ieee.org,
.\"                        (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "bibliography, BibTeX, searching",
.\"     supported       = "yes",
.\"     docstring       = "This file contains the UNIX manual pages
.\"                        for the bibsearch utility, an interface to
.\"                        a fast database search engine for searching
.\"                        BibTeX bibliography files.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.\" TO DO:  How to get accented letters without using ISO8859-1
.\"         encoding?  This file requires a-umlaut, o-umlaut, and
.\"         e-acute.
.\"
.\" ANSWER: BWK reports that AT&T/Lucent troff is 8-bit clean, and
.\"         ISO 8859-1 encodings can be used as long as the associated
.\"         fonts have the needed accented characters.
.\"
.\"         GNU groff has macros \(:a, \(:e, \('e, ... defined in
.\"         /usr/local/lib/groff/tmac/tmac.latin1, and accepts either
.\"         these macros, or the 8-bit ISO 8859-1 representations.  It
.\"         behaves consistently, and correctly, on all tested systems.
.\"
.\"         Non-groff implementations do not recognize the groff accent
.\"         macros.
.\"
.\"         However, other systems are less predictable when given the
.\"         ISO 8859-1 encodings:
.\"
.\"         Apple Rhapsody 5.6:  /usr/bin/troff -man preserves the
.\"                             accented characters correctly.
.\"                             /usr/bin/nroff -man drops the accents.
.\"
.\"         Compaq/DEC OSF/1 4.0: /usr/bin/nroff -man preserves the
.\"                             accented characters correctly.
.\"                             troff is not available.
.\"
.\"         FreeBSD 4.1.1:      /usr/bin/troff -man preserves the
.\"                             accented characters correctly.
.\"                             /usr/bin/nroff -man drops the accents.
.\"
.\"         GNU/Linux 2.2.16-3smp: /usr/bin/troff -man -Tps converts a-umlaut to
.\"                             a, o-umlaut to o, and e-acute to e.
.\"                             /usr/bin/nroff -man drops the accents.
.\"
.\"         HP HP-UX 10.01:     troff is not available.
.\"                             /usr/bin/nroff -man converts a-umlaut to ae,
.\"                             o-umlaut to oe, and e-acute to e.
.\"
.\"         IBM RS/6000 AIX 4.3.2: /usr/bin/nroff -man preserves the
.\"                             accented characters correctly.
.\"                             Although troff is available, there is no
.\"                             installed PostScript support, despite
.\"                             its being documented in the troff manual
.\"                             pages!
.\"
.\"         SGI IRIX 6.5:       /bin/psroff -man converts a-umlaut to ae,
.\"                             o-umlaut to oe, and e-acute to e.
.\"                             Neither nroff nor troff are available.
.\"
.\"         Sun Solaris 2.7:    /bin/troff -Tpost -man | /usr/lib/lp/postscript/dpost
.\"                             converts a-umlaut to d, o-umlaut to v, and
.\"                             e-acute to i.
.\"                             /bin/nroff -man core dumps
.\"
.\"         Thus, only groff can be portably relied on to display these
.\"         accents correctly.
.\"
.\"         This file also requires fixed-width font support, via \fC...\fP;
.\"         only groff consistently provides this on all systems.
.\"
.if n .ds Bi BibTeX
.if t .ds Bi B\s-2IB\s0T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.\"
.if n .ds Ps PostScript
.if t .ds Ps P\s-2OST\s0S\s-2CRIPT\s0
.\"
.if n .ds Te TeX
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.\"
.\"======================================================================
.TH BIBSEARCH 1 "13 February 2001" "Version 2.00"
.\"======================================================================
.SH NAME
bibsearch \- search BibTeX bibliography files
.\"======================================================================
.SH SYNOPSIS
.B bibsearch
[
.BI \-\|\-bibsearchpath " dirname[:dirname:dirname:.\|.\|.]"
]
.if n .ti +10n
[
.B \-\|\-?
]
[
.B \-\|\-debug
]
[
.B \-\|\-help
]
.if t .ti +\w'\fBbibsearch\fP\ 'u
[
.B \-\|\-quiet
]
.if n .ti +10n
[
.B \-\|\-version
]
[
.I databasename
]
.\"======================================================================
.SH DESCRIPTION
.B bibsearch
uses the
.BR mgquery (1)
database search engine to provide superfast
searching in one of several collections of \*(Bi\&
bibliography database files.  The most active
databases are generally updated nightly.
.B bibsearch
normally displays the date of the last update,
plus some statistics on the size of the
collection.  It also gives some helpful hints
about commonly-used commands.
.PP
Multiple databases are available, and others may
be added from time to time without updating this
documentation, or the installed
.B bibsearch
software; use the
.B \-\|\-help
option occasionally to find out what databases are
currently installed.
.PP
The
default database at the
.B bibsearch
development site at the University of Utah
Mathematics Department is
.BR tug ,
the largest, and most active.  The default may be
different at your site; use the
.B \-\|\-help
option to find out.
.PP
At the time of writing, these databases are
available:
.\"-----------------------------------------------
.TP \w'\fBkarlsruhe\fP'u+2n
.B dblp
Universitt Trier, Germany, Digital Bibliography
and Library Project (DBLP) bibliography archive.
Coverage of computer science journals,
conferences, and technical reports, with more than
187,000 entries
.RB [ "updated irregularly" ].
.\"-----------------------------------------------
.TP
.B karlsruhe
Universitt Karlsruhe, Germany, combined
world-wide Computer Science bibliography archive,
with more than 965,000 entries
.RB [ "updated weekly" ].
This collection includes a major part of the
.B tug
archive described below, but its file mirror may
often be weeks or months behind.
.\"-----------------------------------------------
.TP
.B mathutah
Mathematics Department, University of Utah,
research groups bibliographies, with about 200,000
entries
.RB [ "updated nightly" ].
.\"-----------------------------------------------
.TP
.B tug
BibNet Project and \*(Te\& User Group combined
bibliography archive, with more than 279,000
entries
.RB [ "updated nightly" ].
As of early 2001, the
.B tug
collection includes about 200 journal-specific
bibliographies, of which about 70 provide
.I complete
coverage of their respective journals.
.IP
The archives covers these subject areas in
computer science, electronic document
representation, and mathematics:
.RS
.\"-----------------------------------------------
.TP \w'\(bu'u+1n
\(bu
ANSI, IEC, IEEE, Internet, and ISO computer-related
standards;
.\"-----------------------------------------------
.TP
\(bu
.I "American Mathematical Monthly"
and
.I "Canadian Journal of Mathematics"
==
.IR "Journal canadien de mathmatiques" ;
.\"-----------------------------------------------
.TP
\(bu
computer architectures (Intel IA-64 and visual
instruction sets);
.\"-----------------------------------------------
.TP
\(bu
computer arithmetic;
.\"-----------------------------------------------
.TP
\(bu
computer graphics and visualization;
.\"-----------------------------------------------
.TP
\(bu
computer science conferences and journals
.RI ( hundreds " of them);"
.\"-----------------------------------------------
.TP
\(bu
cryptanalysis, cryptography, cryptohistory,
cryptology, and encryption;
.\"-----------------------------------------------
.TP
\(bu
database research;
.\"-----------------------------------------------
.TP
\(bu
electronic document representation;
.\"-----------------------------------------------
.TP
\(bu
fonts;
.\"-----------------------------------------------
.TP
\(bu
GNU Project of the Free Software Foundation;
.\"-----------------------------------------------
.TP
\(bu
HTML and SGML, and other SGML-based markup
languages, such as ChemML, MathML, MusicML, VRML,
and XML;
.\"-----------------------------------------------
.TP
\(bu
Internet;
.\"-----------------------------------------------
.TP
\(bu
.I "Lecture Notes in Computer Science"
and
.IR "Lecture Notes in Computational Science and Engineering" ;
.\"-----------------------------------------------
.TP
\(bu
literate programming;
.\"-----------------------------------------------
.TP
\(bu
mathematical physics (one journal only);
.\"-----------------------------------------------
.TP
\(bu
numerical linear algebra;
.\"-----------------------------------------------
.TP
\(bu
operating systems (GNU/Linux, Mach, Plan9, UNIX);
.\"-----------------------------------------------
.TP
\(bu
page representation languages (\*(Ps\& and PDF);
.\"-----------------------------------------------
.TP
\(bu
programming languages (Axiom, BMDP, Fortran, Icon,
Java, Macsyma, Maple, Mathematica, \*(Ps\&,
Python, Reduce, SAS, S-Plus, SPSS);
.\"-----------------------------------------------
.TP
\(bu
quantum chemistry (one journal, one book series,
and one personal bibliography, only);
.\"-----------------------------------------------
.TP
\(bu
statistics;
.\"-----------------------------------------------
.TP
\(bu
supercomputing;
.\"-----------------------------------------------
.TP
\(bu
symbolic algebra;
.\"-----------------------------------------------
.TP
\(bu
\*(Te\& and Metafont;
.\"-----------------------------------------------
.TP
\(bu
typography and typesetting;
.\"-----------------------------------------------
.TP
\(bu
Unicode; and
.\"-----------------------------------------------
.TP
\(bu
the X Window System.
.RE
.\"======================================================================
.SH OPTIONS
All options can be abbreviated to a unique leading
prefix, and either the normal UNIX single-hyphen
prefix, or the GNU/POSIX double-hyphen prefix, may
be used.
.\"-----------------------------------------------
.TP \w'\fIdatabasename\fP'u+2n
.BI \-\|\-bibsearchpath " dirname[:dirname:dirname:.\|.\|.]"
Provide a search path of one or more directory trees in which to
find
.BR mg (1)
databases, overriding the normal installation
default of
.RI \fC/usr/local/src/bibdata\fP .
Each directory in the search path contains a
separate subdirectory for each database, and each
such subdirectory contains an \fCmgdata/bibfiles\fP
subdirectory with the actual files used by
.BR mgquery (1).
.IP
Multiple
.B \-\|\-bibsearchpath
options accumulate, to avoid long ugly
colon-separated directory lists.
.IP
Since a particular user will often want to specify
the same search path each time
.B bibsearch
is run, the path can also be set as the value of
the
.B BIBSEARCHPATH
environment variable.  However, command-line use
of
.B \-\|\-bibsearchpath
overrides any
.B BIBSEARCHPATH
setting.
.IP
As a special convenience, an empty directory path
element, represented by a leading or trailing
colon, or two adjacent colons between directory
names, is replaced by the local system default
.B bibsearch
directory search path.  This makes it easy for
users to
.IR augment ,
rather than
.IR override ,
the search path, and to do so
.I "without having to know what the default search path is."
.IP
Thus, a typical user setting might be
.RS
.RS
.nf
.I $HOME/bib:
.fi
.RE
.RE
.IP
to put the user's own databases ahead of the
system ones, overriding any of those with the same
names as the user's databases, or
.RS
.RS
.nf
.I :$HOME/bib
.fi
.RE
.RE
.IP
to put them behind the system ones, preventing
hiding of the system databases.
.IP
It is possible for the directory path to include
directories to which the current user does not
have read access; such directories will be
silently ignored.  This feature is intentional: it
makes it possible for individual users, or groups,
to register their databases with the local
.B bibsearch
installer, who need only augment the
.B DEFAULTBIBSEARCHPATH
setting in the installed
.B bibsearch
program, so that they automatically see them when
they run
.BR bibsearch .
However, by suitable setting of directory
permissions, they can control access by others,
without having to involve local system management.
.IP
This feature is not necessarily antisocial and
unfriendly.  Bibliographic data is largely
entered by humans, so it is highly error prone.  A
user might wish to have personal
.B bibsearch
access to rough bibliographic data that has not
yet been polished up enough for public view.  Once
that cleanup happens, a simple directory
permission change can instantly release the data
to others on the local system.
.\"-----------------------------------------------
.TP
.B \-\|\-?
Same as
.BR \-\|\-help .
Since the query character is significant to UNIX
shells, you have to suitably quote it: write
.BR \-\|\-\'?\' ,
\&\fB\-\|\-"?"\fP,
or
.BR \-\|\-\e? .
.\"-----------------------------------------------
.TP
.B \-\|\-debug
Turn on debug tracing, showing the directory
path search operation, and the
.B mgquery (1)
environment and invocation.  Debug messages
are written to
.IR stderr .
.IP
Although it should rarely be necessary, you can
also define the
.B DEBUG
environment variable to a nonempty string to turn
on debugging.  This lets it take effect a little
earlier than if it were requested on the command
line.
.\"-----------------------------------------------
.TP
.B \-\|\-help
Give a brief help message on
.IR stdout ,
show the system, user, and expanded directory
search paths, list the available databases, and
exit with a success return code (0 on UNIX).
.\"-----------------------------------------------
.TP
.B \-\|\-quiet
Suppress the display of the usual verbose startup
banner that offers brief instructions for
.BR mgquery (1)
search techniques.
.\"-----------------------------------------------
.TP
.B \-\|\-version
Display the program version number and data on
.IR stdout ,
and exit with a success return code (0 on UNIX).
.\"-----------------------------------------------
.TP
.I databasename
Specify the database to use, overriding the
default.  Use the
.B \-\|\-help
option to get a list of available databases, with
brief descriptions, and to show the system, user,
and expanded directory search paths.
.IP
At the
.B bibsearch
development site, this list includes at least
these:
.BR dblp ,
.BR karlsruhe ,
.BR mathutah ,
and
.BR tug .
.\"======================================================================
.SH SEARCHING
The
.BR mg (1)
search engine in
.B bibsearch
is very simple to use: almost anything that you
type is treated as text to search for, and the
search begins when you end your input line.
.PP
.BR mg (1)
commands begin with an initial period, and are
discussed further below.
.PP
Each search result normally begins with a
separator line of dashes, followed by a World-Wide
Web
.I "Universal Resource Locator"
(URL) address that uniquely identifies the
location of the bibliography file.
Here is an example, from a search for
.IR "Knuth typesetting book":
.RS
.nf
\&\fC---------------------------------- 65786

URL = ftp://ftp.math.utah.edu/pub/tex/bib/font.bib Line=1453

KEYWORDS = display generation printing publishing

@Book{Knuth:1979:TMN,
  author =       "D. E. Knuth",
  title =        "{TEX} and {METAFONT}, New Directions in
                 Typesetting",
  publisher =    "Digital Press",
  address =      "Billerica, MA",
  pages =        "360",
  year =         "1979",
  ISBN =         "0-932376-02-9",
  LCCN =         "Z253.3 .K58 1979",
  bibdate =      "Tue May 12 10:13:36 1998",
  bibsource =    "Graphics/imager/imager.books.bib,
                 Graphics/siggraph/79.bib,
                 ftp://ftp.math.utah.edu/pub/tex/bib/siggraph/new/79.bib",
  annote =       "A landmark book at the time it was
                 published. Newer versions exist. Less than
                 portable as claimed, but still significant.
                 Required reading for anyone doing font
                 design and type setting.",
  keywords =     "general references, standards text books,
                 software, programming systems, character
                 display/generation, Applications,
                 printing/publishing industry, general
                 references, standards text books and
                 software, programming systems, character
                 display/generation and Applications,
                 printing/publishing industry",
}

---------------------------------- 65934
\fP
.fi
.RE
.PP
Each output \*(Bi\& entry is surrounded by blank
lines (a
.I paragraph
in \*(Te\&) for better visibility, and to
facilitate easy text selection in GNU
.BR emacs (1):
put the cursor anywhere in the entry, and type M-h
.RI ( mark-paragraph )
then M-w
.RI ( kill-ring-save )
to copy the text into the editor and window system
paste buffers.  Text processing languages, like
.BR awk (1),
.BR icon (1),
.BR perl (1),
and
.BR ruby (1),
and search utilities like
.BR agrep (1)
and
.BR glimpse (1),
also have simple mechanisms for dealing with
paragraph-sized chunks of text.
.PP
Searches always
.I ignore
letter case.
.PP
Searching is based on
.BR word s,
where a
.B word
is a consecutive string of
.IR letters ,
.IR digits ,
.I hyphen
.RI ( dash " or " minus ),
.IR underscore ,
.IR backslash ,
or
.IR apostrophe .
This permits searching for ordinary words, as well
as for ISSN and ISBN values, for programming
language variable names, for \*(Te\& control
sequences, and for names like ``O'Reilly''.
.PP
All other characters are treated as word
separators, so to search for
.RI `` input/output '',
you must search for two words,
.RI `` input ''
and
.RI `` output ''.
Similarly, you could search for an
e-mail address
.RI `` rms@gnu.org ''
with the
string
.RI `` "rms gnu org" '',
assuming the default query-ranked search mode.
.PP
Partial word matches are not usually accepted: if
you search for ``tex'', neither ``text'' nor
``texture'' will match. However,
.BR mg (1)
will `stem' search words, removing common English
suffixes, so a search for
.RI `` mathematical ''
will first be reduced to
.RI `` mathemat ''
and that will match
.RI `` mathematical '',
.RI `` mathematics '',
and
.RI `` mathematician ''.
Regrettably, the current version of
.BR mgquery (1)
does not provide any way to suppress this
stemming, with the result that searches often
return much more than you really want.
.PP
By default,
.B bibsearch
uses query-ranked searching: you type several
words, and the search engine responds with a
sorted list of bibliography entries that contain
one or more of those words, in order of decreasing
number of matches.
.PP
To switch to Boolean searching, which allows
combination of words with Boolean AND (&), OR (|),
and NOT (!) operators, issue the
.BR mgquery (1)
command
.RS
.nf
\&\fC.set query boolean\fP
.fi
.RE
.PP
You may find that using
.RS
.nf
\&\fC.set mode hilite\fP
.fi
.RE
makes it easier to spot the matched strings in the
output.  However, the highlighting requires
additional control characters that contaminate any
output directed to a file, so in such a case, you
should turn it off, by, e.g.,
.RS
.nf
\&\fC.set mode text\fP
\&\fC.set pager "cat >>/tmp/foo.log"\fP
.fi
.RE
.PP
At the
.B bibsearch
development site, local users can see these files
directly in the UNIX network file system, without
having to launch
.BR ftp (1)
or a Web browser: just change the prefix
\&\fCftp://ftp.math.utah.edu\fP to \&\fC/u/ftp\fP
to create a local file name.  This may be handy if
you want to find related bibliography entries
serendipitously, without knowing exactly what they
contain.
.PP
For further information on searching with
.BR mgquery (1),
consult its manual pages, or
use its
.RS
.nf
\&\fC.help\fP
.fi
.RE
command.
.PP
Finally, to exit from
.BR bibsearch ,
use the
.BR mgquery (1)
.RS
.nf
\&\fC.quit\fP
.fi
.RE
command.
.PP
With each \*(Bi\& entry retrieved,
.B bibsearch
provides definitions of any \*(Bi\& strings used
in the entry.  This will likely result in many
duplicate string definitions, but they are easily
eliminated by a subsequent pass of the
bibliography data through
.BR bibsort (1).
Acknowledgement strings are not included in this
output, because they are often large, and because
few, if any, \*(Bi\& styles use them.  You can
find their definitions near the top of the
original \*(Bi\& file identified at the start of
each search result.
.\"======================================================================
.SH "RELIABILITY OF BIBLIOGRAPHIC DATA"
Although bibliographic data may be stored on a
computer, it is ultimately generated by humans,
and in the case of commercial databases, probably
by low-paid, unskilled, offshore typists with no
personal interest in accuracy.  Worse, they are
probably paid for speed and quantity, rather than
quality.
.PP
Several years of experience with bibliographic
data from many sources, both commercial and
public, has amply demonstrated that if errors can
be made, they will be!  Among the common errors
repeatedly seen are:
.RS
.\"-----------------------------------------------
.TP \w'\(bu'u+1n
\(bu
Misspelled author names.
.\"-----------------------------------------------
.TP
\(bu
Omitted accents in author names.
.\"-----------------------------------------------
.TP
\(bu
Silent truncation of author lists, and in the case
of one commercial database, the even worse
practice of recording only the first two authors,
plus the last!
.\"-----------------------------------------------
.TP
\(bu
Replacement of authors after the first by the
anonymous
.I "et al." .
A colleague once quipped that if you hear of work
credited to Jones et al., it means that Jones got
the credit, but Al did the work!
.IP
Scientific document production is now mostly done
electronically, so shortcuts of the past that were
used primarily to reduce the tedium of manual
typing of reference lists, such as omitting
subsequent authors, abbreviating personal names or
journal names, and eliding common digits of ending
page numbers (983--7 instead of 983--987), should
be abandoned.  The document is now likely to
preserved in electronic form by the publisher, and
those shortcuts interfere with subsequent reuse,
and with searching.
.IP
A few journals already hyperlink citations to
entries in reference lists, and inverting those
hyperlinks produces answers to the very important
question, ``Who cited this article?'', a question
that up to now could be answered only through
Science Citation Index, or its variants in other
fields.
.\"-----------------------------------------------
.TP
\(bu
Reduction of author personal names to initials,
sometimes without final periods, or even
separating spaces.  In some languages, there are
human names that require only a single letter, so
a serious ambiguity is introduced by this
reduction.
.\"-----------------------------------------------
.TP
\(bu
Misordering of author names occurs far too often.
Even publishers are sometimes inconsistent here
between table of contents and article.
.\"-----------------------------------------------
.TP
\(bu
Omission of spaces and hyphens, and loss of
capitalization, in compound names.  Science
Citation Index reduces
.I "Joop van der Vliet"
to
.IR "J. Vandervliet" ,
.I "H. Fallah-Adl"
to
.IR "H. Fallahadl" ,
and
.I "S. McQueen"
to
.IR "S. Mcqueen" .
.\"-----------------------------------------------
.TP
\(bu
Dropping of Jr.-like author name suffixes.
.\"-----------------------------------------------
.TP
\(bu
Inconsistent handling of Chinese, Japanese, and
Hungarian author names.  In those languages, and
possibly others, family names are given before the
personal name.  In the absence of bibliography
markup of family names, it would be more
consistent to place the family name last, e.g.,
.I "Paul Erds" ,
instead of
.IR "Erds Pal" ,
and
.I "Bao-Wen Li"
instead of
.IR "Li Bao-Wen".
A future version of \*(Bi\& may have markup syntax
to address this problem, while preserving the
native name order, but until then, the common
European name order should be adhered to.
.\"-----------------------------------------------
.TP
\(bu
Incorrect abbreviation of Spanish names, which
often have a paternal family name, followed by a
maternal family name, often separated by
.IR y " (and)."
Thus,
.I "Javier Gomez Romero"
should not be abbreviated as
.I "J. G. Romero"
or
.I "Javier G. Romero" .
For \*(Bi\& use, enter such a name like this:
.IR "Javier {Gomez Romero}" .
.\"-----------------------------------------------
.TP
\(bu
Confusion between editor and author.  This is a
frequent problem for journals that carry monthly
columns with both a regular column editor, and an
author varying by issue.  Several IEEE journals do
this.  The \*(Bi\& entry should list the author,
not the editor.
.\"-----------------------------------------------
.TP
\(bu
Errors in titles, sometimes making them
unrecognizable. Part of this problem can be traced
back to publishers, editors, and marketing people
who prepare tables of contents with titles that
only vaguely resemble the actual article titles.
Some commercial databases seem to input their data
almost exclusively from tables-of-contents
listings, so the errors propagate.
.\"-----------------------------------------------
.TP
\(bu
Changes of spelling between American and British
English.
.IP
Databases should record the original data exactly,
not convert it to the orthographic practices of
the country where it happens to be stored!
.IP
When spelling errors occur in the original data,
they can be marked with the time-honored Latin
insertion
.RI [ sic ].
.\"-----------------------------------------------
.TP
\(bu
Changing arabic numbers in titles to English, or
vice-versa (a very common error in Science
Citation Index).
.\"-----------------------------------------------
.TP
\(bu
Errors from optical character recognition (OCR)
when publication data is scanned in as bitmaps and
converted to text by a computer program:
.I ri
becomes
.IR n ,
.I ni
becomes
.IR m ,
.I 1
becomes
.IR l ,
and so on.
.\"-----------------------------------------------
.TP
\(bu
Errors in year, volume, issue, month, and page
numbers, and sometimes, even getting the journal
completely wrong.
.\"-----------------------------------------------
.TP
\(bu
Omission of publication month and, where relevant,
day.
.\"-----------------------------------------------
.TP
\(bu
Omission of final page numbers, even though it is
required practice in many fields to include both
initial and final page numbers in article
citations.
.\"-----------------------------------------------
.TP
\(bu
Off-by-one final page numbers, probably from
faulty assumptions about whether new articles
start on an odd-numbered page or not.
.\"-----------------------------------------------
.TP
\(bu
Off-by-one initial page numbers from confusion
over where an article starts.
.IP
Citations for the
.I "Communications of the ACM"
frequently exhibit this problem: since a design
change in July 1990, articles often have
background artwork on two facing pages, and huge
and horridly scaled typefaces.  The foreground and
background colors and patterns often clash, to the
point of being unreadable, and the weird layout of
author names and titles leaves the reader
thoroughly confused.
.\"-----------------------------------------------
.TP
\(bu
Converting journal titles to all uppercase
(a major failing of Science Citation Index).
.\"-----------------------------------------------
.TP
\(bu
Dropping of punctuation:
.I O'Neill
becomes
.I ONeill
and
.I "What's New?"
becomes
.IR "Whats New" .
.\"-----------------------------------------------
.TP
\(bu
Insertion of bogus hyphens between title words
(a practice that is endemic in Science Citation Index).
.RE
.PP
The lack of support for accents, and for
mathematical markup, is a huge problem for
scientific bibliographic data.  Only the American
and European Mathematical Society databases, which
store their data with \*(Te\& markup, routinely
include accents and proper math markup, although
for historical reasons, the EMS databases
typically use transliterations of German accented
letters.  Among all the commercial databases that
I have used, the quality of entries in the AMS and
EMS databases is notably better than all others,
and they deserve a lot of credit for that.
.PP
The attempt at representing mathematics in many
other databases cannot be termed other than
bizarre and incomprehensible; they don't even
attempt to do something sensible, like spell out
the names of the symbols, but instead, substitute
utter nonsense.  Yet, mathematics is common in
publication titles in the physical sciences.
.PP
Speakers of largely accent-free languages, like
English, tend to be insensitive to the
significance of accents in other languages.  In
many languages, accented letters are not just
variants of the base letter, they are
.IR "completely different letters" ,
with different sounds and different alphabet
positions.  Just as English would become
unreadable if the vowels were reduced from
.I aeiou
to, say, just
.IR aiu ,
other languages suffer similarly when accents are
lost.  Here is the previous sentence with that
reduction:
.RS
Just as Inglish wuuld bicumi
unriadabli if thi vuwils wiri riducid frum
.I aiiuu
tu, say, just
.IR aiu ,
uthir languagis suffir similarly whin accints ari
lust.
.RE
.PP
In view of these myriad deficiencies, what can be
done?
.PP
The best way would be for commercial databases and
publishers to do the job right in the first place!
.PP
Ultimately, commercial databases should get all of
their data directly from publishers, instead of
indirectly by retyping and/or OCR.  Publishers
have the original bibliographic information, and
the capability to preserve that information, and
make it available; at present, few do.
.PP
If publishers do not supply the correct
information in rigorously-marked-up electronic
form, then data should come from multiple sources
and be merged in such a way that discrepancies are
revealed.  Commercial databases could have the
data typed or scanned twice by independent
contractors, for example, and then merge the
results: discrepancies indicate errors.
Researchers should enter bibliographic data
directly from the original publications, or if
those are unavailable, at least find multiple
.I independent
instances of citations to those publications.
.PP
The
.BR bibjoin (1)
utility is a good example of software that can
help a lot in this process.  It uses a number of
heuristics to maximize the data retained after a
merge, and yet preserves conflicting information
when it cannot decide which of multiple choices is
the right one, leaving it up to a human editor to
resolve discrepancies.  Consult its manual pages
for more information about how it operates.
.PP
However, merging of data from two sources is
insufficient: both might have derived their data
from inaccurate tables of contents.
.PP
For these reasons, the BibNet Project and TUG
archives include data merged from several sources,
and credit those sources in
.I bibsource
string values.  In addition, for many recent
journals, the data is derived directly by computer
software from data at publisher World-Wide Web
sites.  For
.I some
of the larger scientific publishers, this has
proved to be an acceptable approach, although
confirmation from other sources is still
desirable.
Consequently, the
.B tug
collection in
.B bibsearch
will be found to be a substantially more reliable
source than the other collections, which are
mostly single source, and parts of them are very
poorly and sloppily done.
.PP
The significant differences in quality is why
separate databases are maintained for
.BR bibsearch ,
rather than merging all available data into one
master database.  While it is technologically
feasible to do that, the user would then be unable
to assess the quality of the results of a search,
and the wheat could be buried in chaff.
.\"======================================================================
.SH "DIRECTORIES AND FILES"
.\"-----------------------------------------------
.\".TP \w'\fC/usr/local/src/bibdata\fP'u+2n
.TP \w'\fCxxx/mgbuild\fP'u+2n
\&\fC/usr/local/src/bibdata\fP
Installation-default
.B bibsearch
database directory search path.
.\"-----------------------------------------------
.TP
\&\fC$HOME/.mgrc\fP
User's personal configuration file for
.BR mgquery (1).
.\"-----------------------------------------------
.TP
\&\fCxxx/DESCRIPTION\fP
Text file to provide brief descriptions of
the contents of database
.BR xxx .
The
.B bibsearch
.B \-\|\-help
option uses this file to prepare its database
summary.
.\"-----------------------------------------------
.TP
\&\fCxxx/mgbuild\fP
Temporary directory tree used by
.BR mgbuild (1)
while creating a new database named
.BR xxx .
.IP
After successful completion of the build, a fast
directory renaming operation exchanges
\&\fCxxx/mgbuild\fP and \&\fCxxx/mgdata\fP to make
the newer one current.  Since the old one remains
available, just under a different directory name,
open files in use by all running
.B bibsearch
or
.BR mgquery (1)
jobs are unaffected.
.IP
Even when the old \&\fCxxx/mgbuild\fP tree is
emptied immediately prior to the next scheduled
database update, already-open files still remain
available to running processes (but are no longer
associated with a named file directory), so
database updates never cause user search-process
failure, but newly-added data will not be seen
until the user search processes are restarted.
.\"-----------------------------------------------
.TP
\&\fCxxx/mgdata/bibfiles/STATS.*\fP
Statistics files for database
.BR xxx .
.B bibsearch
uses the contents of these files in its welcome
banner, with a report like this:
.RS
.nf
\&\fCLast database update: Thu Feb  1 17:09:26 MST 2001
Bibliography entries:     278378
Bibliography lines:      5682256
Bibliography bytes:    216614068\fP
.fi
.RE
.\"-----------------------------------------------
.TP
\&\fCxxx/mgdata/bibfiles/bibfiles.*\fP
.BR mg (1)
binary index files for database
.BR xxx .
These contain
.I all
of the data originally found in the \*(Bi\& files,
but in a binary, compact, and heavily-indexed,
form that can be accessed very quickly by
.BR mgquery (1).
They typically take about 40% of the initial data
size.  The original \*(Bi\& files are never used
by
.BR mgquery (1).
.\"-----------------------------------------------
.TP
\&\fCxxx/mgdata/mg_get\fP
UNIX shell script helper program used by
.BR mgbuild (1)
to create a marked-up data stream for indexing.
It contains sections for handling data in various
formats, and needs no modifications until data in
a new format needs to be indexed.
.\"-----------------------------------------------
.TP
\&\fCxxx/mgdata/mg_get_bibtex.awk\fP
Filter program used by
.B mg_get
to add
.BR mgbuild (1)
markup to a \*(Bi\& data stream.  It assumes that
the data has been put into a standard format by
.BR bibclean (1),
and generally needs no site-specific or
user-specific modifications.
.IP
The database build time depends critically on the
performance of this program.  The current version
is run with
.BR mawk (1),
because that proved to be several times faster
than with
.BR awk (1),
.BR gawk (1),
.BR nawk (1),
and even with a highly compiler-optimized
translation from awk to C with
.BR awka (1)!
It now accounts for about half the total CPU time
of the build of the
.B tug
database, for which
.BR mgbuild (1)
processes about 7MB of clean \*(Bi\& data per
minute, or 420MB per hour, on a 400MHz Sun
UltraSPARC II file server.
.\"======================================================================
.SH "ENVIRONMENT VARIABLES"
.\"-----------------------------------------------
.TP \w'\fBBIBSEARCHPATH\fP'u+2n
.B BIBSEARCHPATH
User-defined default
.B bibsearch
database directory search path.  It overrides, or
augments, the local system-wide
.B bibsearch
search path, and is in turn overridden by any
command-line
.B \-\|\-bibsearchpath
option.  See that option's description in the
.B OPTIONS
section above for further details on how to define
a directory search path.
.TP
.B DEBUG
If this is set to an arbitrary nonempty value,
turn on debug tracing.  This is almost the same as
using the command-line
.B \-\|\-debug
option, but makes the tracing take effect a little
sooner.
.\"======================================================================
.SH "SEE ALSO"
.BR agrep (1),
.BR awk (1),
.BR bibcheck (1),
.BR bibclean (1),
.BR bibdup (1),
.BR bibextract (1),
.BR bibjoin (1),
.BR biblabel (1),
.BR biblex (1),
.BR biborder (1),
.BR bibparse (1),
.BR bibsort (1),
.BR bibsplit (1),
.BR bibtex (1),
.BR bibunlex (1),
.BR citesub (1),
.BR emacs (1),
.BR glimpse (1),
.BR icon (1),
.BR mg (1),
.BR mgbuild (1),
.BR mgquery (1),
.BR perl (1),
.BR ruby (1).
.\"======================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe, Ph.D.
Center for Scientific Computing
University of Utah
Department of Mathematics, 322 INSCC
155 S 1400 E RM 233
Salt Lake City, UT 84112-0090
USA
Email: \fCbeebe@math.utah.edu\fP, \fCbeebe@acm.org\fP,
       \fCbeebe@computer.org\fP, \fCbeebe@ieee.org\fP (Internet)
WWW URL: \fChttp://www.math.utah.edu/~beebe\fP
Telephone: +1 801 581 5254
FAX: +1 801 585 1640, +1 801 581 4148
.fi
.\"=====================================================================
.SH AVAILABILITY
.B bibsearch
is freely available; its master distribution can
be found at
.PP
.RS
.nf
\&\fCftp://ftp.math.utah.edu/pub/mg/mg-1.3x\fP
\&\fChttp://www.math.utah.edu/pub/mg/mg-1.3x\fP
.fi
.RE
.PP
in the files
.RS
.nf
.I bibsearch-x.yy.jar
.I bibsearch-x.yy.tar.gz
.I bibsearch-x.yy.zip
.I bibsearch-x.yy.zoo
.fi
.RE
where
.I x.yy
is the current version.  Each of the popular
archive format unpacks into an identical
distribution tree.
.PP
That site is mirrored to several other Internet
archives, so you may also be able to find it
elsewhere on the Internet; try searching for the
string
.I bibsearch
at one or more of the popular Web search sites,
such as
.PP
.RS
.nf
\&\fChttp://search.microsoft.com/
http://www.altavista.com/
http://www.dejanews.com/
http://www.dogpile.com/
http://www.euroseek.net/
http://www.excite.com/
http://www.go2net.com/
http://www.google.com/
http://www.hotbot.com/
http://www.infoseek.com/
http://www.inktomi.com/
http://www.lycos.com/
http://www.northernlight.com/
http://www.snap.com/
http://www.stpt.com/
http://www.websmostlinked.com/
http://www.yahoo.com/\fP
.fi
.RE
.\"=====================================================================
.SH COPYRIGHT
.nf
\fC########################################################################
########################################################################
########################################################################
###                                                                  ###
###            bibsearch: search BibTeX bibliography files           ###
###                                                                  ###
###            Copyright (C) 1997, 2000 Nelson H. F. Beebe           ###
###                                                                  ###
### This program is covered by the GNU General Public License (GPL), ###
### version 2 or later, available as the file COPYING in the program ###
### source distribution, and on the Internet at                      ###
###                                                                  ###
###               ftp://ftp.gnu.org/gnu/GPL                          ###
###                                                                  ###
###               http://www.gnu.org/copyleft/gpl.html               ###
###                                                                  ###
### This program is free software; you can redistribute it and/or    ###
### modify it under the terms of the GNU General Public License as   ###
### published by the Free Software Foundation; either version 2 of   ###
### the License, or (at your option) any later version.              ###
###                                                                  ###
### This program is distributed in the hope that it will be useful,  ###
### but WITHOUT ANY WARRANTY; without even the implied warranty of   ###
### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    ###
### GNU General Public License for more details.                     ###
###                                                                  ###
### You should have received a copy of the GNU General Public        ###
### License along with this program; if not, write to the Free       ###
### Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   ###
### MA 02111-1307 USA                                                ###
########################################################################
########################################################################
########################################################################\fP
.fi
.\"==============================[The End]==============================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
