.TH PLUTO 1L "10 August 1986"
.SH NAME
pluto \-  molecular and crystalline graphics system from <PLOT79> package
.SH SYNOPSIS
.B pluto[1,4,b,r,s,v,z] [<\fIinputfile\fP] [>\fIlogfile\fP]
.sp
where the final character indicates the desired output device
(4 for the Tektronix 4014 in the default Sun installation:
see \fIplot79\fP manual page for complete list)
.SH DESCRIPTION
.I Pluto
is a system for computer generation of molecular and crystalline graphics;
this version is adapted from the original and is distributed with the <PLOT79>
computer graphics package.  If no files are specified on the command line,
the program looks for a file named \fIpluto.cmd\fP in the current directory,
which is assumed to contain the required file names.  If no such
file exists, the program will send prompts to the standard output asking for
\fIpluto\fP commands.  Log information is sent to the standard output.  
The plottable output is sent to a file named by the CRT environment variable,
or to \fICRT.num\fP if CRT is undefined
(\fInum\fP is a number which begins at 1 and is
incremented appropriately to prevent files being overwritten).
.\"the names of data, list, and plot files.  All file names must consist of
.\"at most six characters optionally followed by a period and an extension of at
.\"most three characters.  The default extensions for command, data, list,
.\"and plot files are \fI.cmd\fP, \fI.dat\fP, \fI.lst\fP, and \fI.plt\fP,
.\"respectively.  The extensions may be omitted.  Data files are assumed to
.\"contain \fIpluto\fP commands; a list file will contain messages from the
.\"program, and a plot file will contain graphics commands.
.LP
.\"If any of the file names are omitted, or the command file does not supply
.\"them, the name of any preceding file is assumed, so that one need type a
.\"file name only once.  The default file name is \fIpluto\fP, so that if no file
.\"names are supplied, the following are sought: \fIpluto.dat\fP, \fIpluto.lst\fP,
.\"and \fIpluto.plt\fP.
.LP
\fIPluto\fP commands are concerned with three aspects of molecular
graphics: content (the definition
of items such as molecules or a unit cell), style (wire-frame or
ball-and-spoke or space filling model, with or without shading
of atoms and tapering of bonds, in various colors, with labels
in various fonts, using monocular or stereographic projections, with or without
a superimposed perspective grid), and viewpoint (distance, direction,
orthographic or perspective projection).  Consult the User's Guide for
detailed instructions.
.SH FILES
.TP 2.2i
/usr/local/plot79/plutodir/*
files required to make \fIpluto\fP
.TP
/usr/local/plot79/pluto*
executable file (pluto4 on the default Sun installation)
.TP
/usr/local/plot79/define
various environment definitions, an appropriate subset of which should be
placed in the user's \fI.cshrc\fP or \fI.profile\fP file
.SH "SEE ALSO"
document (1L), drawit(1L), grapht(1L), graph3t(1L), lptops(1L), pfort(1L),
piechtt(1L), plot79.intro(1L), plot79(1L), pretty(1L), rdinfo(1L),
sf3(1L), slides(1L), tekalw(1L), tkvecs(1L), tmacro(1L), world(1L)
.LP
\fIA User's Guide to PLUTO.  A Program for Plotting Molecular and Crystal
Structures\fP.  Sam Motherwell, Joel Sussman, Zappora Shakked, David Barnett,
and Nelson Beebe.  Depts. of Physics and Chemistry, University of
Utah.
.SH AUTHOR
The original PLUTO was authored by:
.br
Sam Motherwell
.br
University Chemical Laboratory
.br
Lensfield Road, Cambridge CB2 1EW United Kingdom
.LP
It was subsequently revised and extended by:
.br
Joel L. Sussman, Zappora Shakked, and David Barnett
.br
Weizmann Institute of Science, Rehovoth, Israel.
.LP
It was further modified for purposes of portability, performance,
and device independence by:
.br
Nelson H. F. Beebe, Ph.D.
.br
Center for Scientific Computing
.br
South Physics Building
.br
University of Utah
.br
Salt Lake City, UT 84112
.br
Tel: (801) 581-5254
.br
(Manual page by R. P. C. Rodgers, Computer Applications in Laboratory
Medicine Project, UCSF, San Francisco, CA 94143).
